vtkDepthImageProcessingPass Class Reference

Convenient class for post-processing passes. Based on vtkImageProcessingPass, but writes depth as well in a texture. More...

`#include <vtkDepthImageProcessingPass.h>`

Inheritance diagram for vtkDepthImageProcessingPass:
[legend]
Collaboration diagram for vtkDepthImageProcessingPass:
[legend]

## Public Types

typedef vtkImageProcessingPass | Superclass
Public Types inherited from vtkImageProcessingPass
typedef vtkOpenGLRenderPass | Superclass
Public Types inherited from vtkOpenGLRenderPass
typedef vtkRenderPass | Superclass
Public Types inherited from vtkRenderPass
typedef vtkObject | Superclass

## Public Member Functions

virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkDepthImageProcessingPass * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
Public Member Functions inherited from vtkImageProcessingPass
vtkImageProcessingPass * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | ReleaseGraphicsResources (vtkWindow *w) override
| Release graphics resources and ask components to release their own resources. More...
virtual vtkRenderPass * | GetDelegatePass ()
| Delegate for rendering the image to be processed. More...
virtual void | SetDelegatePass (vtkRenderPass *delegatePass)
Public Member Functions inherited from vtkOpenGLRenderPass
vtkOpenGLRenderPass * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | PreReplaceShaderValues (std::string &vertexShader, std::string &geometryShader, std::string &fragmentShader, vtkAbstractMapper *mapper, vtkProp *prop)
| Use vtkShaderProgram::Substitute to replace //VTK::XXX:YYY declarations in the shader sources. More...
virtual bool | PostReplaceShaderValues (std::string &vertexShader, std::string &geometryShader, std::string &fragmentShader, vtkAbstractMapper *mapper, vtkProp *prop)
| Use vtkShaderProgram::Substitute to replace //VTK::XXX:YYY declarations in the shader sources. More...
virtual bool | SetShaderParameters (vtkShaderProgram *program, vtkAbstractMapper *mapper, vtkProp *prop, vtkOpenGLVertexArrayObject *VAO=nullptr)
| Update the uniforms of the shader program. More...
virtual vtkMTimeType | GetShaderStageMTime ()
| For multi-stage render passes that need to change shader code during a single pass, use this method to notify a mapper that the shader needs to be rebuilt (rather than reuse the last cached shader. More...
virtual void | SetActiveDrawBuffers (unsigned int)
| Number of active draw buffers. More...
virtual unsigned int | GetActiveDrawBuffers ()
Public Member Functions inherited from vtkRenderPass
vtkRenderPass * | NewInstance () const
virtual void | Render (const vtkRenderState *s)=0
| Perform rendering according to a render state `s`. More...
virtual int | GetNumberOfRenderedProps ()
| Number of props rendered at the last Render call. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions

static vtkTypeBool | IsTypeOf (const char *type)
static vtkDepthImageProcessingPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkImageProcessingPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImageProcessingPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkOpenGLRenderPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkOpenGLRenderPass * | SafeDownCast (vtkObjectBase *o)
static vtkInformationObjectBaseVectorKey * | RenderPasses ()
| Key containing information about the current pass. More...
Static Public Member Functions inherited from vtkRenderPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkRenderPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions

virtual vtkObjectBase * | NewInstanceInternal () const
| vtkDepthImageProcessingPass ()
| Default constructor. More...
| ~vtkDepthImageProcessingPass () override
| Destructor. More...
virtual void | RenderDelegate (const vtkRenderState *s, int width, int height, int newWidth, int newHeight, vtkOpenGLFramebufferObject *fbo, vtkTextureObject *colortarget, vtkTextureObject *depthtarget)
| Render delegate with a image of different dimensions than the original one. More...
void | ReadWindowSize (const vtkRenderState *s)
| Read parent size - for sake of code clarity This function is generic, can be useful in multiple image-based rendering classes. More...
Protected Member Functions inherited from vtkImageProcessingPass
| vtkImageProcessingPass ()
| Default constructor. More...
| ~vtkImageProcessingPass () override
| Destructor. More...
void | RenderDelegate (const vtkRenderState *s, int width, int height, int newWidth, int newHeight, vtkOpenGLFramebufferObject *fbo, vtkTextureObject *target)
| Render delegate with a image of different dimensions than the original one. More...
Protected Member Functions inherited from vtkOpenGLRenderPass
| vtkOpenGLRenderPass ()
| ~vtkOpenGLRenderPass () override
void | PreRender (const vtkRenderState *s)
| Call before rendering to update the actors' information keys. More...
void | PostRender (const vtkRenderState *s)
| Call after rendering to clean up the actors' information keys. More...
Protected Member Functions inherited from vtkRenderPass
| vtkRenderPass ()
| Default constructor. More...
| ~vtkRenderPass () override
| Destructor. More...
void | UpdateCamera (vtkRenderer *renderer)
| Call UpdateCamera() on Renderer. More...
void | ClearLights (vtkRenderer *renderer)
| Call ClearLights() on Renderer. More...
void | UpdateLightGeometry (vtkRenderer *renderer)
| Call UpdateLightGeometry() on Renderer. More...
void | UpdateLights (vtkRenderer *renderer)
| Call UpdateLights() on Renderer. More...
void | UpdateGeometry (vtkRenderer *renderer, vtkFrameBufferObjectBase *fbo=nullptr)
| Call UpdateGeometry() on Renderer. More...
void | SetLastRenderingUsedDepthPeeling (vtkRenderer *renderer, bool value)
| Modify protected member LastRenderingUsedDepthPeeling on Renderer. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes

int | Origin [2]
int | Width
int | Height
int | W
int | H
int | ExtraPixels
Protected Attributes inherited from vtkImageProcessingPass
vtkRenderPass * | DelegatePass
Protected Attributes inherited from vtkOpenGLRenderPass
unsigned int | ActiveDrawBuffers = 0
Protected Attributes inherited from vtkRenderPass
int | NumberOfRenderedProps
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

Convenient class for post-processing passes. Based on vtkImageProcessingPass, but writes depth as well in a texture.

Abstract class with some convenient methods frequently used in subclasses.

See also
  vtkRenderPass vtkDepthImageProcessingPass vtkEDLShading

Definition at line 45 of file vtkDepthImageProcessingPass.h.

## Member Typedef Documentation

## Superclass

typedef vtkImageProcessingPass vtkDepthImageProcessingPass::Superclass

Definition at line 48 of file vtkDepthImageProcessingPass.h.

## Constructor & Destructor Documentation

## vtkDepthImageProcessingPass()

vtkDepthImageProcessingPass::vtkDepthImageProcessingPass | ( |  | ) |

protected

Default constructor.

DelegatePass is set to NULL.

## ~vtkDepthImageProcessingPass()

vtkDepthImageProcessingPass::~vtkDepthImageProcessingPass | ( |  | ) |

override protected

Destructor.

## Member Function Documentation

## IsTypeOf()

static vtkTypeBool vtkDepthImageProcessingPass::IsTypeOf | ( | const char * | type | ) |

static

## IsA()

virtual vtkTypeBool vtkDepthImageProcessingPass::IsA | ( | const char * | name | ) |

virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkImageProcessingPass.

Reimplemented in vtkEDLShading, vtkDepthOfFieldPass, vtkPointFillPass, vtkSimpleMotionBlurPass, and vtkFramebufferPass.

## SafeDownCast()

static vtkDepthImageProcessingPass* vtkDepthImageProcessingPass::SafeDownCast | ( | vtkObjectBase * | o | ) |

static

## NewInstanceInternal()

virtual vtkObjectBase* vtkDepthImageProcessingPass::NewInstanceInternal | ( |  | ) | const

protected virtual

Reimplemented from vtkImageProcessingPass.

Reimplemented in vtkEDLShading, vtkDepthOfFieldPass, vtkPointFillPass, vtkSimpleMotionBlurPass, and vtkFramebufferPass.

## NewInstance()

vtkDepthImageProcessingPass* vtkDepthImageProcessingPass::NewInstance | ( |  | ) | const

## PrintSelf()

void vtkDepthImageProcessingPass::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |

override virtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkRenderPass.

Reimplemented in vtkEDLShading, vtkDepthOfFieldPass, vtkPointFillPass, vtkSimpleMotionBlurPass, and vtkFramebufferPass.

## RenderDelegate()

virtual void vtkDepthImageProcessingPass::RenderDelegate | ( | const vtkRenderState * | s,
|  | int | width,
|  | int | height,
|  | int | newWidth,
|  | int | newHeight,
|  | vtkOpenGLFramebufferObject * | fbo,
|  | vtkTextureObject * | colortarget,
|  | vtkTextureObject * | depthtarget
| ) |  |

protected virtual

Render delegate with a image of different dimensions than the original one.

Precondition
  s_exists: s!=0
  fbo_exists: fbo!=0
  fbo_has_context: fbo->GetContext()!=0
  colortarget_exists: colortarget!=0
  colortarget_has_context: colortarget->GetContext()!=0

## ReadWindowSize()

void vtkDepthImageProcessingPass::ReadWindowSize | ( | const vtkRenderState * | s | ) |

protected

Read parent size - for sake of code clarity This function is generic, can be useful in multiple image-based rendering classes.

Precondition
  s_exists: s!=0

## Member Data Documentation

## Origin

int vtkDepthImageProcessingPass::Origin[2]

protected

Definition at line 82 of file vtkDepthImageProcessingPass.h.

## Width

int vtkDepthImageProcessingPass::Width

protected

Definition at line 83 of file vtkDepthImageProcessingPass.h.

## Height

int vtkDepthImageProcessingPass::Height

protected

Definition at line 84 of file vtkDepthImageProcessingPass.h.

## W

int vtkDepthImageProcessingPass::W

protected

Definition at line 85 of file vtkDepthImageProcessingPass.h.

## H

int vtkDepthImageProcessingPass::H

protected

Definition at line 86 of file vtkDepthImageProcessingPass.h.

## ExtraPixels

int vtkDepthImageProcessingPass::ExtraPixels

protected

Definition at line 87 of file vtkDepthImageProcessingPass.h.

The documentation for this class was generated from the following file:

- Rendering/OpenGL2/vtkDepthImageProcessingPass.h